#include <iostream>
#include <fstream>
#include <map>
#include <algorithm>
using namespace std;

#define ll long long
 
ll N;
 
struct kulup { 
  int n;
  int k[5]; 
};

kulup K[100000];

kulup altkumeHesapla(kulup &a, int x)
{
  kulup sonuc = { 0, {0,0,0,0,0} };
  for (int j=0; j<5; j++)
    if ((1<<j)&x) sonuc.k[sonuc.n++] = a.k[j];
  return sonuc;
}
 
bool operator< (const kulup &a, const kulup &b)
{
  for (int j=0; j<5; j++) {
    if (a.k[j] < b.k[j]) return true;
    if (a.k[j] > b.k[j]) return false;
  }
  return false;
}
 
int main()
{
  ll icerme[] = { -1, +1, -1, +1, -1, +1 };
  map<kulup, int> altTercih;

  cin >> N;

  for (int i=0; i<N; i++) {
    K[i].n = 5;
    for (int j=0; j<5; j++) 
      	cin >> K[i].k[j];
    sort(K[i].k, K[i].k+5);
    for (int x=1; x<32; x++) 
	altTercih[altkumeHesapla(K[i], x)]++;
  }
 
  ll cvp = N * (N-1) / 2;
  for (auto &p : altTercih) 
    cvp -= icerme[p.first.n] * p.second * (p.second - 1) / 2;
  
  cout << cvp << "\n";
  return 0;
}
